
'$DYNAMIC
DEFINT A-Z

DECLARE SUB RemoveObject ()
DECLARE SUB Display (array%(), MapX%, MapY%, MaxX%, MaxY%, Trans%, CLayer%)
DECLARE SUB PlaceRemoveObjects ()
DECLARE FUNCTION FreeObject% ()
DECLARE SUB WipeMap ()
DECLARE SUB BsaveX (file$, SGment%, Offset%, NumBytes!, FilePointer!)
DECLARE SUB LoadMap ()
DECLARE SUB SaveMap ()
DECLARE SUB DoMouseJunk ()
DECLARE SUB UpdateButtons (Xposition%, Yposition%)
DECLARE SUB CenterCamera ()
DECLARE SUB FontPrint (textstring$, X%, Y%)
DECLARE SUB BloadX (file$, SGment%, Offset%, NumBytes!, FilePointer!)
DECLARE SUB Keys ()

DECLARE SUB Loadtiles ()
DECLARE SUB Intro ()
DECLARE SUB ScreenX (modenumber%)
DECLARE SUB LoadPal (filename$)
'$INCLUDE: 'asm.inc'
'$INCLUDE: 'types.inc'



CONST TRUE = -1
CONST FALSE = 0

DIM SHARED MoveX
DIM SHARED ShowTile
DIM SHARED CurrentTile
DIM SHARED currentlayer
DIM SHARED MoveY
DIM SHARED MouseX, MouseY
DIM SHARED MouseButton
DIM SHARED holder(163)
DIM SHARED mouse(33)
DIM SHARED ReasonToQuit
DIM SHARED CameraX, CameraY, CenteredCameraX, CenteredCameraY
DIM SHARED tiles(32759)
DIM SHARED buttons(203)
DIM SHARED TileData(251) AS TileTableData
DIM SHARED solid(129)
DIM SHARED Chargraph(3095, 5)
DIM SHARED MapLevel1(89, 89)
DIM SHARED maplevel2(89, 89)
DIM SHARED MapLevel3(89, 89)
DIM SHARED objectlevel1(89, 89)
DIM SHARED objectlevel2(89, 89)
DIM SHARED objectlevel3(89, 89)
DIM SHARED keyboardbuffer(255)
DIM SHARED keyboard AS KeyBoardProfile
DIM SHARED bottombar(1281)
DIM SHARED NumButtons, ButtonStatus(5)
DIM SHARED Frames&
DIM SHARED buffer(31999)
DIM SHARED font(4351)
DIM SHARED objects(63) AS ObjectData
DIM SHARED StartTime!
SetSegments13h VARSEG(buffer(0)), &HA000

ScreenX 19

LoadPal "qb.pal"

Loadtiles


keyboard.placeobject = 24
keyboard.RemoveObject = 23
keyboard.Console = 35
keyboard.UpArrow = 72
keyboard.DownArrow = 80
keyboard.LeftArrow = 75
keyboard.RightArrow = 77
keyboard.FastQuit = 1

FOR i = 0 TO 63
objects(i).objecttype = -1
objects(i).currentlayer = -1
NEXT i

FOR i = 0 TO 251
TileData(i).Segment = VARSEG(tiles(130 * i))
TileData(i).Offset = VARPTR(tiles(130 * i))
TileData(i).AnimationFrames = 1
TileData(i).AnimationDelayFrames = 0
NEXT i

FOR i = 0 TO 89
FOR j = 0 TO 89
objectlevel1(i, j) = -1
objectlevel2(i, j) = -1
objectlevel3(i, j) = -1
NEXT j, i
LoadMap

ShowTile = 1
ButtonStatus(0) = 1
ButtonStatus(1) = 1
ButtonStatus(2) = 1
ButtonStatus(3) = 1
initkbd VARSEG(keyboardbuffer(0)), VARPTR(keyboardbuffer(0))
CurrentTile = 8
currentlayer = 0
StartTime! = TIMER

DO
Frames& = Frames& + 1
Keys
CenterCamera
IF ButtonStatus(0) THEN Display MapLevel1(), CenteredCameraX, CenteredCameraY, 19, 11, 1, 0
IF ButtonStatus(1) THEN Display maplevel2(), CenteredCameraX, CenteredCameraY, 19, 11, 1, 1
IF ButtonStatus(2) THEN Display MapLevel3(), CenteredCameraX, CenteredCameraY, 19, 11, 1, 2
put13h VARSEG(bottombar(0)), VARPTR(bottombar(0)), 0, 192, -1
UpdateButtons 48, 192
FontPrint STR$(CenteredCameraX) + STR$(CenteredCameraY), 180, 192
'FontPrint STR$(objectlevel2(0, 0)) + STR$(objectlevel2(1, 0)), 180, 192
FontPrint STR$(FreeObject), 0, 192
'IF TIMER - StartTime! > 1 THEN FontPrint STR$(Frames& \ (TIMER - StartTime!)), 0, 192
IF ShowTile THEN put13h VARSEG(holder(0)), VARPTR(holder(0)), 302, 0, -1: put13h TileData(CurrentTile).Segment, TileData(CurrentTile).Offset, 303, 1, -1
put13h VARSEG(mouse(0)), VARPTR(mouse(0)), MouseX, MouseY, 0
WAIT &H3DA, 8
Copy13h
ReasonToQuit = keyboardbuffer(keyboard.FastQuit)
LOOP UNTIL ReasonToQuit
deinitkbd



ScreenX 3

REM $STATIC
SUB BloadX (file$, SGment, Offset, NumBytes!, FilePointer!)


file$ = file$ + CHR$(0) 'must have a NULL for int to terminate.
regs.ax = &H3D00
regs.ds = VARSEG(file$) 'segment of name
regs.dx = SADD(file$)  'offset of name
CALL INTERRUPTX(&H21, regs, regs)
regs.bx = regs.ax 'filehandle


regs.ax = &H4200
regs.cx = VAL("&H" + HEX$(INT(FilePointer! / 65536)))
regs.dx = VAL("&H" + HEX$(FilePointer! MOD 65536))
CALL INTERRUPTX(&H21, regs, regs)

regs.ax = &H3F00
regs.cx = VAL("&H" + HEX$(NumBytes!))
regs.ds = VAL("&H" + HEX$(SGment))
regs.dx = VAL("&H" + HEX$(Offset))
CALL INTERRUPTX(&H21, regs, regs)

regs.ax = &H3E00
CALL INTERRUPTX(&H21, regs, regs)

END SUB

SUB BsaveX (file$, SGment, Offset, NumBytes!, FilePointer!)

OPEN file$ FOR BINARY AS #5
CLOSE #5


file$ = file$ + CHR$(0)
regs.ax = &H3D01
regs.ds = VARSEG(file$)  'segment of filename
regs.dx = SADD(file$) 'offset of filename
CALL INTERRUPTX(&H21, regs, regs)
regs.bx = regs.ax 'filehandle

regs.ax = &H4200
regs.cx = VAL("&H" + HEX$(INT(FilePointer! / 65536)))
regs.dx = VAL("&H" + HEX$(FilePointer! MOD 65536))
CALL INTERRUPTX(&H21, regs, regs)

'saves the screen into the file
regs.ax = &H4000
regs.cx = VAL("&H" + HEX$(NumBytes!))
regs.ds = VAL("&H" + HEX$(SGment))
regs.dx = VAL("&H" + HEX$(Offset))
CALL INTERRUPTX(&H21, regs, regs)


'close the file
regs.ax = &H3E00
CALL INTERRUPTX(&H21, regs, regs)




END SUB

SUB CenterCamera
CenteredCameraX = CameraX
CenteredCameraY = CameraY
IF CenteredCameraX < 0 THEN CenteredCameraX = 0
IF CenteredCameraY < 0 THEN CenteredCameraY = 0
IF CenteredCameraY > 1248 THEN CenteredCameraY = 1248
IF CenteredCameraX > 1120 THEN CenteredCameraX = 1120
END SUB

SUB Display (array(), MapX, MapY, MaxX, MaxY, Trans%, CLayer)
StartX = -(MapX AND 15)
StartY = -(MapY AND 15)
StartMapX = MapX \ 16
StartMapY = MapY \ 16
LocationX = StartX
EndX = MaxX + (-(SGN(StartX)))
endy = MaxY + (-(SGN(StartY)))
FOR showx = 0 TO EndX
LocationY = StartY
FOR showy = 0 TO endy
til = array(StartMapX + showx, StartMapY + showy) MOD 252
IF TileData(til).AnimationFrames <> 1 THEN til = til + ((Frames& \ TileData(til).AnimationDelayFrames) MOD (TileData(til).AnimationFrames))
SELECT CASE Trans%
CASE 1
IF til <> 0 THEN put13h TileData(til).Segment, TileData(til).Offset, LocationX, LocationY, 0
CASE ELSE
put13h TileData(til).Segment, TileData(til).Offset, LocationX, LocationY, -1
END SELECT
IF array(StartMapX + showx, StartMapY + showy) > 251 THEN put13h VARSEG(solid(0)), VARPTR(solid(0)), LocationX, LocationY, 0
LocationY = LocationY + 16
NEXT showy
LocationX = LocationX + 16
NEXT showx

FOR showy = 0 TO endy + 2
FOR showx = 0 TO EndX + 1
SELECT CASE CLayer
CASE 0
ObjectTest = objectlevel1(StartMapX + showx, StartMapY + showy)
CASE 1
ObjectTest = objectlevel2(StartMapX + showx, StartMapY + showy)
CASE 2
ObjectTest = objectlevel3(StartMapX + showx, StartMapY + showy)
END SELECT
IF ObjectTest > -1 THEN
IF objects(ObjectTest).objecttype > -1 THEN
IF objects(ObjectTest).currentlayer = currentlayer THEN
junkvar = 0
SELECT CASE objects(ObjectTest).CharSetTile
CASE -1
put13h TileData(objects(ObjectTest).TileNumber).Segment, TileData(objects(ObjectTest).TileNumber).Offset, objects(ObjectTest).PixelLocationX - MapX, objects(ObjectTest).PixelLocationY - MapY, 0
CASE ELSE
put13h VARSEG(Chargraph(junkvar, objects(ObjectTest).CharSetTile)), VARPTR(Chargraph(junkvar, objects(ObjectTest).CharSetTile)), objects(ObjectTest).PixelLocationX - MapX, objects(ObjectTest).PixelLocationY - MapY - 16, 0
'put13h VARSEG(CharSet(junkvar, 1)), VARPTR(CharSet(junkvar, 1)), Objects(ObjectTest).PixelLocationX - MapX, Objects(ObjectTest).PixelLocationY - MapY - 16, 0
END SELECT
END IF
END IF
END IF
NEXT showx, showy

END SUB

SUB DoMouseJunk
IF MouseY < 192 THEN
MapTestX = (MouseX) \ 16
MapTestY = (MouseY) \ 16
SELECT CASE currentlayer
CASE 0
MapLevel1((CenteredCameraX \ 16) + MapTestX, (CenteredCameraY \ 16) + MapTestY) = CurrentTile + ((MouseButton = 2) * -252)
CASE 1
maplevel2((CenteredCameraX \ 16) + MapTestX, (CenteredCameraY \ 16) + MapTestY) = CurrentTile + ((MouseButton = 2) * -252)
CASE 2
MapLevel3((CenteredCameraX \ 16) + MapTestX, (CenteredCameraY \ 16) + MapTestY) = CurrentTile + ((MouseButton = 2) * -252)
END SELECT
ELSE
IF MouseX >= 48 AND MouseX <= 71 THEN
JunkX = (MouseX - 48) \ 8
IF ButtonStatus(JunkX) = 0 THEN ButtonStatus(JunkX) = 1 ELSE ButtonStatus(JunkX) = 0
END IF

IF MouseX >= 120 AND MouseX <= 143 THEN
JunkX = ((MouseX - 120) \ 8)
ButtonStatus(currentlayer + 3) = 0
currentlayer = JunkX
ButtonStatus(currentlayer + 3) = 1
END IF

DO
regs.ax = 3
INTERRUPTX &H33, regs, regs
MouseButton = regs.bx
LOOP UNTIL MouseButton = 0

END IF



END SUB

SUB FontPrint (textstring$, X, Y)
FOR i = 1 TO LEN(textstring$)
til = 34 * ASC(MID$(textstring$, i, 1))
put13h VARSEG(font(til)), VARPTR(font(til)), X + (i * 8), Y, 0
NEXT
END SUB

FUNCTION FreeObject%
FOR CheckFree = 0 TO 63
IF objects(CheckFree).objecttype = -1 THEN FreeObject% = CheckFree: EXIT FUNCTION
NEXT
FreeObject% = -1
END FUNCTION

SUB Keys
CurrentTile = CurrentTile + (keyboardbuffer(13) - keyboardbuffer(12)): DO: LOOP UNTIL keyboardbuffer(13) = 0 AND keyboardbuffer(12) = 0
IF CurrentTile < 0 THEN CurrentTile = 0
IF CurrentTile > 251 THEN CurrentTile = 251
IF keyboardbuffer(31) THEN SaveMap
IF keyboardbuffer(38) THEN LoadMap
IF keyboardbuffer(19) THEN WipeMap
CameraX = CameraX + (16 * (keyboardbuffer(keyboard.RightArrow) - keyboardbuffer(keyboard.LeftArrow)))
CameraY = CameraY + (16 * (keyboardbuffer(keyboard.DownArrow) - keyboardbuffer(keyboard.UpArrow)))
IF CameraX < 0 THEN CameraX = 0
IF CameraY < 0 THEN CameraY = 0
IF CameraY > 1248 THEN CameraY = 1248
IF CameraX > 1120 THEN CameraX = 1120
regs.ax = 3
INTERRUPTX &H33, regs, regs
MouseButton = regs.bx
MouseX = regs.cx \ 2
MouseY = regs.dx
IF MouseButton <> 0 THEN DoMouseJunk
IF keyboardbuffer(keyboard.placeobject) THEN PlaceRemoveObjects: DO: LOOP UNTIL keyboardbuffer(keyboard.placeobject) = 0
IF keyboardbuffer(keyboard.RemoveObject) THEN RemoveObject: DO: LOOP UNTIL keyboardbuffer(keyboard.RemoveObject) = 0
IF keyboardbuffer(keyboard.Console) THEN DO: LOOP UNTIL keyboardbuffer(keyboard.Console) = 0: SELECT CASE ShowTile: CASE 0: ShowTile = 1: CASE 1: ShowTile = 0: END SELECT
END SUB

SUB LoadMap
BloadX "map\Map.DAT", VARSEG(MapLevel1(0, 0)), VARPTR(MapLevel1(0, 0)), 16200, 0
BloadX "map\Map.DAT", VARSEG(maplevel2(0, 0)), VARPTR(maplevel2(0, 0)), 16200, 16200
BloadX "map\Map.DAT", VARSEG(MapLevel3(0, 0)), VARPTR(MapLevel3(0, 0)), 16200, 32400
DO: LOOP UNTIL keyboardbuffer(38) = 0
END SUB

SUB LoadPal (filename$)
FileNum = FREEFILE
OPEN "pal\" + filename$ FOR BINARY AS #FileNum
OUT &H3C8, 0
FOR i = 0 TO 767
OUT &H3C9, ASC(INPUT$(1, FileNum))
NEXT
END SUB

SUB Loadtiles
DEF SEG = VARSEG(Chargraph(0, 0))
BLOAD "put\char.put", VARPTR(Chargraph(0, 0))
DEF SEG = VARSEG(solid(0))
BLOAD "put\solid.put", VARPTR(solid(0))
DEF SEG = VARSEG(holder(0))
BLOAD "put\holder.put", VARPTR(holder(0))
DEF SEG = VARSEG(tiles(0))
BLOAD "put\tiles.put", VARPTR(tiles(0))
DEF SEG = VARSEG(mouse(0))
BLOAD "put\mouse.put", VARPTR(mouse(0))
DEF SEG = VARSEG(buttons(0))
BLOAD "put\buttons.put", VARPTR(buttons(0))
DEF SEG = VARSEG(bottombar(0))
BLOAD "put\bottom.put", VARPTR(bottombar(0))
DEF SEG = VARSEG(font(0))
BLOAD "put\font.put", VARPTR(font(0))
DEF SEG
END SUB

SUB PlaceRemoveObjects
IF MouseY < 192 THEN
MapTestX = (MouseX) \ 16
MapTestY = (MouseY) \ 16
obj = FreeObject%
IF obj = -1 THEN EXIT SUB
SELECT CASE currentlayer
CASE 0
IF objectlevel1((CenteredCameraX \ 16) + MapTestX, (CenteredCameraY \ 16) + MapTestY) = -1 THEN
objectlevel1((CenteredCameraX \ 16) + MapTestX, (CenteredCameraY \ 16) + MapTestY) = obj
objects(obj).objecttype = 1
objects(obj).PixelLocationX = ((CenteredCameraX \ 16) + MapTestX) * 16
objects(obj).PixelLocationY = ((CenteredCameraY \ 16) + MapTestY) * 16
objects(obj).currentlayer = 0
END IF
CASE 1
IF objectlevel2((CenteredCameraX \ 16) + MapTestX, (CenteredCameraY \ 16) + MapTestY) = -1 THEN
objectlevel2((CenteredCameraX \ 16) + MapTestX, (CenteredCameraY \ 16) + MapTestY) = obj
objects(obj).objecttype = 1
objects(obj).PixelLocationX = ((CenteredCameraX \ 16) + MapTestX) * 16
objects(obj).PixelLocationY = ((CenteredCameraY \ 16) + MapTestY) * 16
objects(obj).currentlayer = 1

END IF
CASE 2
IF objectlevel3((CenteredCameraX \ 16) + MapTestX, (CenteredCameraY \ 16) + MapTestY) = -1 THEN
objectlevel3((CenteredCameraX \ 16) + MapTestX, (CenteredCameraY \ 16) + MapTestY) = obj
objects(obj).objecttype = 1
objects(obj).PixelLocationX = ((CenteredCameraX \ 16) + MapTestX) * 16
objects(obj).PixelLocationY = ((CenteredCameraY \ 16) + MapTestY) * 16
objects(obj).currentlayer = 2
END IF
END SELECT
END IF
END SUB

SUB RemoveObject
IF MouseY < 192 THEN
MapTestX = (MouseX) \ 16
MapTestY = (MouseY) \ 16
SELECT CASE currentlayer
CASE 0
obj = objectlevel1((CenteredCameraX \ 16) + MapTestX, (CenteredCameraY \ 16) + MapTestY)
IF obj <> -1 THEN
objectlevel1((CenteredCameraX \ 16) + MapTestX, (CenteredCameraY \ 16) + MapTestY) = -1
objects(obj).objecttype = -1
END IF
CASE 1
obj = objectlevel2((CenteredCameraX \ 16) + MapTestX, (CenteredCameraY \ 16) + MapTestY)
IF obj <> -1 THEN
objectlevel2((CenteredCameraX \ 16) + MapTestX, (CenteredCameraY \ 16) + MapTestY) = -1
objects(obj).objecttype = -1
END IF

CASE 2
obj = objectlevel3((CenteredCameraX \ 16) + MapTestX, (CenteredCameraY \ 16) + MapTestY)
IF obj <> -1 THEN
objectlevel3((CenteredCameraX \ 16) + MapTestX, (CenteredCameraY \ 16) + MapTestY) = -1
objects(obj).objecttype = -1
END IF

END SELECT
END IF

END SUB

SUB SaveMap
BsaveX "map\Map.DAT", VARSEG(MapLevel1(0, 0)), VARPTR(MapLevel1(0, 0)), 16200, 0
BsaveX "map\Map.DAT", VARSEG(maplevel2(0, 0)), VARPTR(maplevel2(0, 0)), 16200, 16200
BsaveX "map\Map.DAT", VARSEG(MapLevel3(0, 0)), VARPTR(MapLevel3(0, 0)), 16200, 32400
DO: LOOP UNTIL keyboardbuffer(31) = 0
END SUB

SUB ScreenX (modenumber)
regs.ax = modenumber
INTERRUPTX &H10, regs, regs
END SUB

SUB UpdateButtons (Xposition, Yposition)
StartX = Xposition
FOR i = 0 TO 2
til = 34 * i
IF ButtonStatus(i) THEN put13h VARSEG(buttons(102 + til)), VARPTR(buttons(102 + til)), StartX, Yposition, -1 ELSE put13h VARSEG(buttons(til)), VARPTR(buttons(til)), StartX, Yposition, -1
StartX = StartX + 8
NEXT
StartX = StartX + 48
FOR i = 0 TO 2
til = 34 * i
IF ButtonStatus(i + 3) THEN put13h VARSEG(buttons(102 + til)), VARPTR(buttons(102 + til)), StartX, Yposition, -1 ELSE put13h VARSEG(buttons(til)), VARPTR(buttons(til)), StartX, Yposition, -1
StartX = StartX + 8
NEXT
END SUB

SUB WipeMap
FOR wipex = 0 TO 89
FOR wipey = 0 TO 89
MapLevel1(wipex, wipey) = 0
maplevel2(wipex, wipey) = 0
MapLevel3(wipex, wipey) = 0
NEXT wipey, wipex
FOR wipex = 0 TO 89
FOR wipey = 0 TO 89
SELECT CASE currentlayer
CASE 0
MapLevel1(wipex, wipey) = CurrentTile
CASE 1
MapLevel1(wipex, wipey) = CurrentTile
CASE 2
MapLevel1(wipex, wipey) = CurrentTile
END SELECT
NEXT wipey, wipex
END SUB

